

class HdaAppPhotosorterInstaller
  def up
    appname = "photosorter"
    app = "hda_app_" + appname
    tgt = "#{HDA_BASE}/platform/html"
    FileUtils.cd("#{HDA_BASE}/platform/apps/#{appname}") do
      FileUtils.cp("app/controllers/#{app}_controller.rb", "#{tgt}/app/controllers")
      FileUtils.cp("app/helpers/#{app}_helper.rb", "#{tgt}/app/helpers")
      FileUtils.cp("app/models/#{app}.rb", "#{tgt}/app/models")
      FileUtils.mkdir_p("#{tgt}/app/views/#{app}")
      FileUtils.cp_r("app/views/#{app}", "#{tgt}/app/views/")
      FileUtils.mkdir_p("#{tgt}/public/images/#{app}")
      FileUtils.cp_r("public/images/.", "#{tgt}/public/images/#{app}/")
    end
    PhotoSorterTable.migrate :up
    pid = HdaPackage.find(:first, :conditions => "name='#{appname}'")[:id]
    HdaApplication.new(:hda_package_id => pid, :hda_user_id => 1).save
    load "#{tgt}/app/models/#{app}.rb"
    load "#{tgt}/app/controllers/#{app}_controller.rb"
    load "#{tgt}/app/helpers/#{app}_helper.rb"
    true
  end

  def down
    # FIXME - this could be simplified to only input the name once
    appname = "photosorter"
    app = "hda_app_" + appname
    tgt = "#{HDA_BASE}/platform/html"
    FileUtils.cd(tgt) do
      FileUtils.rm("app/controllers/#{app}_controller.rb", :force => true)
      FileUtils.rm("app/helpers/#{app}_helper.rb", :force => true)
      FileUtils.rm("app/models/#{app}.rb", :force => true)
      FileUtils.rm_rf("app/views/#{app}")
      FileUtils.rm_rf("public/images/#{app}")
    end
    PhotoSorterTable.migrate :down
    pid = HdaPackage.find(:first, :conditions => "name='#{appname}'")[:id]
    HdaApplication.find(:all, :conditions => "hda_package_id=#{pid}").each {|r| r.destroy}
    #Object.__send__(:remove_const, 'HdaAppSlideshowController')
    #Object.__send__(:remove_const, 'HdaAppSlideshowPhoto')
    #Object.__send__(:remove_const, 'HdaAppSlideshowHelper')
    true
  end

  def user_up u
    true
  end

end

class PhotoSorterTable < ActiveRecord::Migration
  def self.up
    tablename = "hda_app_" + Inflector.pluralize("photosorter")
    begin
        create_table tablename do |t|
          t.column :name, :string
          t.column :service, :string
          t.column :url, :string
        end
        HdaAppPhotosorter.new(:name => "Carlos Puchol Picasa album", :service => 'picasa',
		:url => 'http://picasaweb.google.com/data/feed/base/user/carlos.puchol/albumid/5077165344424241121?kind=photo&alt=rss&hl=en_US').save
        HdaAppPhotosorter.new(:name => "A Flicker album", :service => 'flickr',
		:url => 'http://www.flickr.com/photos/navdeepraj').save
        HdaAppPhotosorter.new(:name => "A few shots of the wild", :service => 'picasa',
		:url => 'http://picasaweb.google.com/data/feed/base/user/3drockz/albumid/5066633507112409985?alt=rss&hl=en_US').save
        HdaAppPhotosorter.new(:name => "A Fotki Album", :service => 'fotki',
		:url => 'http://feeds.fotki.com/SBPhil/album_sqrgrfswftqw.rss').save
        HdaAppPhotosorter.new(:name => "A Photobucket album", :service => 'photobucket',
		:url => 'http://feed0006.photobucket.com/albums/0006/pbhomepage/celebrities/feed.rss').save
    rescue
      #do nothing - the db was already created
    end
    # put some nice default data
  end

  def self.down
    # FIXME
    # dont' destroy data!
    # or ask the user if he/she wants to delete it!
  end
end

